/*
 * 活动报名记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ActivityEnrolRecordController : BaseController
    {
        public ActivityEnrolRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 活动报名记录列表

        /// <summary>
        /// 根据条件查询活动报名记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ActivityEnrolRecord data, string right, string ActId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ActId = ActId;


            string Condition = "";
            
            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询活动报名记录列表

        /// <summary>
        /// 活动报名记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ActivityEnrolRecord data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ActId", "1");

            Fields.Add("CreateDate", "3"); //时间

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ActivityEnrolRecord", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ActId"] = RelationClass.GetActivityInfoInfo(int.Parse(dic["ActId"].ToString()));
                dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加活动报名记录

        /// <summary>
        /// 增加或修改活动报名记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string ActId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ActId = ActId;


            return View();
        }

        #endregion

        #region 增加活动报名记录

        /// <summary>
        /// 增加或修改活动报名记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ActivityEnrolRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ActId", data.ActId);

            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ActivityEnrolRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "ActivityEnrolRecord", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改活动报名记录

        /// <summary>
        /// 增加或修改活动报名记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ActId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ActId = ActId;


            ActivityEnrolRecord editData = db.ActivityEnrolRecord.FirstOrDefault(m => m.Id == Id) ?? new ActivityEnrolRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改活动报名记录

        /// <summary>
        /// 增加或修改活动报名记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ActivityEnrolRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("ActId", data.ActId);

            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityEnrolRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"ActivityEnrolRecord","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除活动报名记录信息

        /// <summary>
        /// 删除活动报名记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ActivityEnrolRecord","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityEnrolRecord", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ActivityEnrolRecord","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityEnrolRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ActivityEnrolRecord","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityEnrolRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ActivityEnrolRecord", Sort, Id);
            
            AddSysLog(Id.ToString(), "ActivityEnrolRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.ActivityEnrolRecord.Add(new ActivityEnrolRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "ActivityEnrolRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ActivityEnrolRecord data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ActivityEnrolRecord", Fields, "Id desc", "0", 1, 20000, "", "ActId,UserId,EnrolMonth,EffectStartTime,EffectEndTime", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ActId"] = RelationClass.GetActivityInfoInfo(int.Parse(dic["ActId"].ToString()));
dic["UserId"] = RelationClass.GetUsersInfo(int.Parse(dic["UserId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ActId", "活动");
ReturnFields.Add("UserId", "创客");
ReturnFields.Add("EnrolMonth", "报名有效月份");
ReturnFields.Add("EffectStartTime", "报名有效开始时间");
ReturnFields.Add("EffectEndTime", "报名有效结束时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ActivityEnrolRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
